﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids.Primitives;
using Infragistics.Controls.Grids;
using System.Windows.Data;
using Infragistics.Controls.Editors;

namespace XamGrid_MVVM_SL
{
    public class CustomDateColumnProvider : ColumnContentProviderBase
    {

        XamMaskedEditor dp;
        TextBlock tb;

        public CustomDateColumnProvider()
        {
            dp = new XamMaskedEditor();// DatePickerMaskedSingleControl();
            dp.Mask = "##/##/##";
            dp.PadChar = '_';
            dp.DataMode = MaskMode.IncludeLiteralsWithPadding;
            dp.DisplayMode = MaskMode.IncludeLiteralsWithPadding;
            dp.ValidationMode = ValidationMode.LostFocus;
            tb = new TextBlock();
            dp.LostFocus += new RoutedEventHandler(dp_LostFocus);
        }

        void dp_LostFocus(object sender, RoutedEventArgs e)
        {
            
        }

        public override FrameworkElement ResolveDisplayElement(Cell cell, Binding cellBinding)
        {

            this.tb.SetBinding(TextBlock.TextProperty, cellBinding);
            return tb;

        }

        protected override System.Windows.FrameworkElement ResolveEditorControl(Cell cell, object editorValue, double availableWidth, double availableHeight, Binding editorBinding)
        {

            this.dp.SetBinding(XamMaskedEditor.ValueProperty, editorBinding);
            return this.dp;
        }

        public override object ResolveValueFromEditor(Cell cell)
        {
            this.dp.Value = this.dp.Text;
            return this.dp.Value;
        }

    }


}
